#include "BP.h"

BP_network::BP_network()
{
	srand((unsigned)time(NULL));
	memset(w, 0, sizeof(w));
	memset(b, 0, sizeof(b));
	memset(Yout, 0, sizeof(Yout));
	memset(DataIn, 0, sizeof(DataIn));
	memset(DataOut, 0, sizeof(DataOut));
	memset(dv, 0, sizeof(dv));
	memset(dw, 0, sizeof(dw));
}

BP_network::~BP_network()
{

}

double BP_network::Random()
{
	double Rand;
	Rand = (1.0*rand()) / (RAND_MAX + 1);
	return Rand;
}
//--------------д-------------------//
void BP_network::FwriteData()
{
	FILE *fp1, *fp2;
	double data1 = 0.0, data2;
	if ((fp1 = fopen("G:\\in.txt", "w")) == NULL) printf("can't open in.txt");
	if ((fp2 = fopen("G:\\out.txt", "w")) == NULL) printf("can't open out.txt");
	for (int i = 0; i < SampleCount; i++)
	{
		//data1 = Random() % 1000 / 100;
		data1 = double(int(Random() * 1000) % 1000) / 100;
		data2 = double(int(Random() * 1000) % 1000) / 100;
		fprintf(fp1,"%lf %lf\n", data1, data2);
		data1 = data1 * data2;
		fprintf(fp2,"%lf \n", data1);
	}
	fclose(fp1);
	fclose(fp2);
}
//---------------------------------//
void BP_network::FreadData()
{
	FILE *fp1, *fp2;
	if (((fp1 = fopen("G:\\in.txt", "r")) == NULL))
		printf("can't open in.txt");
	if((fp2 = fopen("G:\\out.txt", "r")) == NULL)
		printf("can't open in.txt");;
	for (int i = 0; i < SampleCount; i++)
	{
		for (int j = 0; j < InCount; j++)
		{
			fscanf(fp1, "%lf", &DataIn[i][j]);
		}
		fscanf(fp2, "%lf", &DataOut[i][0]);
	}
	fclose(fp1);
	fclose(fp2);
}
//---------һֵȨֵƫõֵ---------//
//****************   ز->=w[i][j][k]     *************//
//------------------  i:j:k:ز    ------//
void BP_network::Init_network()
{
	double InMax, InMin, OutMax, OutMin;
	InMax = DataIn[0][0];
	InMin = DataIn[0][0];
	OutMax = DataOut[0][0];
	OutMin = DataOut[0][0];

	for (int i = 0; i < SampleCount; i++)
	{
		for (int j = 0; j < InCount; j++)
		{
			InMax = InMax > DataIn[i][j] ? InMax : DataIn[i][j];
			InMin = InMin < DataIn[i][j] ? InMin : DataIn[i][j];
		}
		OutMax = OutMax > DataOut[i][0] ? OutMax : DataOut[i][0];
		OutMin = OutMin < DataOut[i][0] ? OutMin : DataOut[i][0];
	}
	for (int i = 0; i < SampleCount; i++)
	{
		for (int j = 0; j < InCount; j++)
		{
			DataIn[i][j] = (DataIn[i][j] - InMin + 1) / (InMax - InMin + 1);
		}
		DataOut[i][0] = (DataOut[i][0] - OutMin + 1) / (OutMax - OutMin + 1);
	}
	for (int j = 0; j < HiddenCount; j++)
	{
		//----------WBֵ------------//
		for (int i = 0; i < LayerCount - 1; i++)
		{
			if (i == 0)//һ
			{
				for (int k = 0; k < InCount; k++)  w[i][k][j] = 2 * (0.5 - Random());
			}
			if (i == 1)//ڶ
			{
				w[i][j][0] = 2 * (0.5 - Random());
			}
		}
		b[0][j] = 1;//Ƚ٣ҪѭֱӸֵ
		b[1][0] = 1;
	}	
	inMax = InMax;
	inMin = InMin;
	outMax = OutMax;
	outMin = OutMin;
}
//-------------------//
void BP_network::DrivingOut(int m)
{
	Yout[1][0] = 0.0;//!!!!!!!!!!!!!ע:δݣ¼!!!!!!!!!!!!!!!!!!!!!
	for (int j = 0; j < HiddenCount; j++)
	{
		Yout[0][j] = 0.0;
		for (int k = 0; k < 2; k++)
		{
			Yout[0][j] += DataIn[m][k] * w[0][k][j];	
		}
		Yout[0][j] += b[0][j];
		Yout[0][j] = Sigmoid(Yout[0][j]);
		Yout[1][0] += Yout[0][j] * w[1][j][0];
	}
	Yout[1][0] += b[1][0];
	Yout[1][0] = Sigmoid(Yout[1][0]);
}
//-----------WBе---------------//
void BP_network::BackAdjust(int m)
{
#if 1//Ӷ
	double StudyRate = 0.0, f = 0.0;
	double Sum = 0.0;
	StudyRate = (Yout[1][0] - DataOut[m][0]) * Yout[1][0] * (1 - Yout[1][0]);
	db0[1][0] = U1*db0[1][0] + (1 - U1)*B_Rate*StudyRate;
	b[1][0] -= db0[1][0];
	for (int i = 0; i < HiddenCount; i++)
	{
		dv[0][i] = U1*dv[0][i] + (1 - U1)*W_Rate * StudyRate * Yout[0][i];
		w[1][i][0] -= dv[0][i];
	}
	for (int i = 0; i < HiddenCount; i++)
	{
		f = 0.0;
		f = StudyRate * w[1][i][0] * Yout[0][i] * (1 - Yout[0][i]);//֮
		for (int j = 0; j < InCount; j++)
		{
			dw[j][i] = U1*dw[j][i] + (1 - U1)*W_Rate * f * DataIn[m][j];
			w[0][j][i] -= dw[j][i];
		}
		db1[0][i] = U1*db0[0][i] + (1 - U1)*B_Rate*f;
		b[0][i] -= db1[0][i];
	}
#endif
#if 0//ҵļһ㶯ǳȶ
	int i, j;
	double t;
	for (i = 0; i < HiddenCount; ++i)
	{
		t = 0;
		for (j = 0; j < OutCount; ++j) {
            t += (Yout[1][j] - DataOut[m][j])*w[1][i][j];
			dv[i][j] = U1*dv[i][j] + (1-U1)*W_Rate*(Yout[1][j] - DataOut[m][j])*Yout[0][i];
			w[1][i][j] -= dv[i][j];
		}
		for (j = 0; j < InCount; ++j) {
			dw[j][i] = U1*dw[j][i] + (1 - U1)*W_Rate*t*Yout[0][i] * (1 - Yout[0][i])*DataIn[m][j];
			w[0][j][i] -= dw[j][i];
		}
}
#endif
#if 0//δӶ
	double StudyRate = 0.0, f = 0.0;
	double Sum = 0.0;
	StudyRate = ( Yout[1][0] - DataOut[m][0]) * Yout[1][0] * (1 - Yout[1][0]);
	b[1][0] -= ETA_W*StudyRate;
	for (int i = 0; i < HiddenCount; i++)  
		w[1][i][0] -= W_Rate * StudyRate * Yout[0][i];
	for (int i = 0; i < HiddenCount; i++)
	{		
		f = 0.0;
		f = StudyRate * w[1][i][0] * Yout[0][i] * (1 - Yout[0][i]);//֮
		for (int j = 0; j < InCount; j++)
		{
			w[0][j][i] -= W_Rate* f *DataIn[m][j];
		}
	   b[0][i] -= ETA_B * f;
	}
#endif
}
//-----------ѵ-----------------//
void BP_network::Train_network()
{
	int Tcount = 0;
	double e = 1.0;
	while (Tcount<TrainCount && e>Accuracy)
	{
		e = 0;
		for (int i = 0; i < SampleCount; i++)
		{
			DrivingOut(i);
			e += fabs((Yout[1][0]-DataOut[i][0])/ DataOut[i][0]);
			BackAdjust(i);
		}
		Tcount++;
		e = e / SampleCount;
		cout << "" << Tcount << "Ϊ" << e << endl;
	}
}

double BP_network::Calculate(double x, double y)
{
	x = (x - inMin + 1) / (inMax - inMin + 1);
	y = (y - inMin + 1) / (inMax - inMin + 1);
#if true
	double sum = 0.0, Tout = 0.0;
	for (int i = 0; i < HiddenCount; i++)
	{
		Yout[0][i] = w[0][0][i] * x + w[0][1][i] * y + b[0][i];
		Yout[0][i] = Sigmoid(Yout[0][i]);
		Tout += Yout[0][i] * w[1][i][0];
	}
	Tout += b[1][0];
	Tout = Sigmoid(Tout);
	return (Tout * (outMax - outMin + 1) + outMin - 1);
#endif
}

double BP_network::Sigmoid(double t)
{
	double sum;
	sum = 1.0 / (1.0+exp(-t));
	return sum;
}

